<html>
<head>
<title>OGRE: Ogre::PixelUtil Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1PixelUtil.html">PixelUtil</a></div>
<h1>Ogre::PixelUtil Class Reference</h1><!-- doxytag: class="Ogre::PixelUtil" -->Some utility functions for packing and unpacking pixel data.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgrePixelFormat_8h-source.html">OgrePixelFormat.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1PixelUtil-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#1e39ec27d40f044a058e6fef850a1fbe">getNumElemBytes</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the size in bytes of an element of the given pixel format.  <a href="#1e39ec27d40f044a058e6fef850a1fbe"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#1dbc281fe64d9f70b3ce5e6d3011cafb">getNumElemBits</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the size in bits of an element of the given pixel format.  <a href="#1dbc281fe64d9f70b3ce5e6d3011cafb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#9f4754892f46c4d17a16374a0d9aade9">getMemorySize</a> (size_t width, size_t height, size_t depth, <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the size in memory of a region with the given extents and pixel format with consecutive memory layout.  <a href="#9f4754892f46c4d17a16374a0d9aade9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#e0c13cd6390b11bc851c9e2ba1201f40">getFlags</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the property flags for this pixel format.  <a href="#e0c13cd6390b11bc851c9e2ba1201f40"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#1e15a9f2c0dc1cba158755633574fbc7">hasAlpha</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shortcut method to determine if the format has an alpha component.  <a href="#1e15a9f2c0dc1cba158755633574fbc7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#478b8c3bbb3bc516f3a06524fc1d9f4b">isFloatingPoint</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shortcut method to determine if the format is floating point.  <a href="#478b8c3bbb3bc516f3a06524fc1d9f4b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#c4fcce8523b25011939624bfe2572314">isCompressed</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shortcut method to determine if the format is compressed.  <a href="#c4fcce8523b25011939624bfe2572314"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#51407cd07e47f24263942453ee4f93af">isDepth</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shortcut method to determine if the format is a depth format.  <a href="#51407cd07e47f24263942453ee4f93af"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#a6a3f3c1e6b98b537ce6dfed949afa3c">isNativeEndian</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shortcut method to determine if the format is in native endian format.  <a href="#a6a3f3c1e6b98b537ce6dfed949afa3c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#7e2ff8ebe2e05d6c0dc5ab725b294cf8">isLuminance</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shortcut method to determine if the format is a luminance format.  <a href="#7e2ff8ebe2e05d6c0dc5ab725b294cf8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#cb83c9058ba34602be4e07e4d7ce1d2d">isValidExtent</a> (size_t width, size_t height, size_t depth, <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return wether a certain image extent is valid for this image format.  <a href="#cb83c9058ba34602be4e07e4d7ce1d2d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#91159ec54a34fca27ccc7621c9b6d957">getBitDepths</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format, int rgba[4])</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gives the number of bits (RGBA) for a format.  <a href="#91159ec54a34fca27ccc7621c9b6d957"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#0ede5a1484d8c57a2cdc87eb4f6d7676">getBitMasks</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format, <a class="el" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> rgba[4])</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gives the masks for the R, G, B and A component.  <a href="#0ede5a1484d8c57a2cdc87eb4f6d7676"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#ec27f7358f77fabc0c9e68ce35b5af69">getFormatName</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> srcformat)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the name of an image format.  <a href="#ec27f7358f77fabc0c9e68ce35b5af69"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#2a9e6ac27e4a4cb2d890d322b3f12c8e">isAccessible</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> srcformat)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns wether the format can be packed or unpacked with the <a class="el" href="classOgre_1_1PixelUtil.html#793a7ae2bb8edec89ab520958ac33f40" title="Pack a colour value to memory.">packColour()</a> and <a class="el" href="classOgre_1_1PixelUtil.html#9b90b16c6c5c8a9fefd42e06a1bd99dc" title="Unpack a colour value from memory.">unpackColour()</a> functions.  <a href="#2a9e6ac27e4a4cb2d890d322b3f12c8e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="namespaceOgre.html#c8f59c884998d9f84d9ea4c66e4c29fe">PixelComponentType</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#90ebf73b3830df2e83d529e60fd8c385">getComponentType</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> fmt)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the component type for a certain pixel format.  <a href="#90ebf73b3830df2e83d529e60fd8c385"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#e81ba2514ca7f5a53c84bb515de2ade0">getComponentCount</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> fmt)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the component count for a certain pixel format.  <a href="#e81ba2514ca7f5a53c84bb515de2ade0"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#601fd16392331e7ddce6bcc455b5729d">getFormatFromName</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, bool accessibleOnly=false, bool caseSensitive=false)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the format from given name.  <a href="#601fd16392331e7ddce6bcc455b5729d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#32443d01d6399f778fce913ca80b0eee">getBNFExpressionOfPixelFormats</a> (bool accessibleOnly=false)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the BNF expression of the pixel-formats.  <a href="#32443d01d6399f778fce913ca80b0eee"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#e127c3e6145af784e7d2d3734681a75a">getFormatForBitDepths</a> (<a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> fmt, <a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> integerBits, <a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> floatBits)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the similar format but acoording with given bit depths.  <a href="#e127c3e6145af784e7d2d3734681a75a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#793a7ae2bb8edec89ab520958ac33f40">packColour</a> (const <a class="el" href="classOgre_1_1ColourValue.html">ColourValue</a> &amp;colour, const <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> pf, void *dest)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pack a colour value to memory.  <a href="#793a7ae2bb8edec89ab520958ac33f40"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#f0658994fbf0337d455ac9aa74ee8084">packColour</a> (const <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> r, const <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> g, const <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> b, const <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> a, const <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> pf, void *dest)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pack a colour value to memory.  <a href="#f0658994fbf0337d455ac9aa74ee8084"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#29490454e6327a0429d19533880f6e2c">packColour</a> (const float r, const float g, const float b, const float a, const <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> pf, void *dest)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pack a colour value to memory.  <a href="#29490454e6327a0429d19533880f6e2c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#9b90b16c6c5c8a9fefd42e06a1bd99dc">unpackColour</a> (<a class="el" href="classOgre_1_1ColourValue.html">ColourValue</a> *colour, <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> pf, const void *src)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unpack a colour value from memory.  <a href="#9b90b16c6c5c8a9fefd42e06a1bd99dc"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#6599a03e4d51ef96f373f47253e2b9e3">unpackColour</a> (<a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> *r, <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> *g, <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> *b, <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> *a, <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> pf, const void *src)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unpack a colour value from memory.  <a href="#6599a03e4d51ef96f373f47253e2b9e3"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#e1448ad9a222ed03918f2e94a057612c">unpackColour</a> (float *r, float *g, float *b, float *a, <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> pf, const void *src)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unpack a colour value from memory.  <a href="#e1448ad9a222ed03918f2e94a057612c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#8d05d1cc543c2618b7ec790648d0ccce">bulkPixelConversion</a> (void *src, <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> srcFormat, void *dest, <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> dstFormat, unsigned int count)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert consecutive pixels from one format to another.  <a href="#8d05d1cc543c2618b7ec790648d0ccce"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1PixelUtil.html#9f6e459a0f92c0c8e6bf4f20ee3a771a">bulkPixelConversion</a> (const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;src, const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;dst)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert pixels from one format to another.  <a href="#9f6e459a0f92c0c8e6bf4f20ee3a771a"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Some utility functions for packing and unpacking pixel data. 
<p>Definition at line <a class="el" href="OgrePixelFormat_8h-source.html#l00272">272</a> of file <a class="el" href="OgrePixelFormat_8h-source.html">OgrePixelFormat.h</a>.</p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="1e39ec27d40f044a058e6fef850a1fbe"></a><!-- doxytag: member="Ogre::PixelUtil::getNumElemBytes" ref="1e39ec27d40f044a058e6fef850a1fbe" args="(PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static size_t Ogre::PixelUtil::getNumElemBytes           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the size in bytes of an element of the given pixel format. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The size in bytes of an element. See Remarks. </dd></dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Passing PF_UNKNOWN will result in returning a size of 0 bytes. </dd></dl>

<p>Referenced by <a class="el" href="OgreImageResampler_8h-source.html#l00180">Ogre::LinearResampler_Float32::scale()</a>, and <a class="el" href="OgreImageResampler_8h-source.html#l00097">Ogre::LinearResampler::scale()</a>.</p>

</div>
</div><p>
<a class="anchor" name="1dbc281fe64d9f70b3ce5e6d3011cafb"></a><!-- doxytag: member="Ogre::PixelUtil::getNumElemBits" ref="1dbc281fe64d9f70b3ce5e6d3011cafb" args="(PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static size_t Ogre::PixelUtil::getNumElemBits           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the size in bits of an element of the given pixel format. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The size in bits of an element. See Remarks. </dd></dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Passing PF_UNKNOWN will result in returning a size of 0 bits. </dd></dl>

</div>
</div><p>
<a class="anchor" name="9f4754892f46c4d17a16374a0d9aade9"></a><!-- doxytag: member="Ogre::PixelUtil::getMemorySize" ref="9f4754892f46c4d17a16374a0d9aade9" args="(size_t width, size_t height, size_t depth, PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static size_t Ogre::PixelUtil::getMemorySize           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>height</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>depth</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the size in memory of a region with the given extents and pixel format with consecutive memory layout. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>width</em>&nbsp;</td><td>The width of the area </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>height</em>&nbsp;</td><td>The height of the area </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>depth</em>&nbsp;</td><td>The depth of the area </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>format</em>&nbsp;</td><td>The format of the area </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The size in bytes </dd></dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>In case that the format is non-compressed, this simply returns width*height*depth*PixelUtilgetNumElemBytes(format). In the compressed case, this does serious magic. </dd></dl>

</div>
</div><p>
<a class="anchor" name="e0c13cd6390b11bc851c9e2ba1201f40"></a><!-- doxytag: member="Ogre::PixelUtil::getFlags" ref="e0c13cd6390b11bc851c9e2ba1201f40" args="(PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static unsigned int Ogre::PixelUtil::getFlags           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the property flags for this pixel format. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>A bitfield combination of PFF_HASALPHA, PFF_ISCOMPRESSED, PFF_FLOAT, PFF_DEPTH, PFF_NATIVEENDIAN, PFF_LUMINANCE </dd></dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This replaces the seperate functions for formatHasAlpha, formatIsFloat, ... </dd></dl>

</div>
</div><p>
<a class="anchor" name="1e15a9f2c0dc1cba158755633574fbc7"></a><!-- doxytag: member="Ogre::PixelUtil::hasAlpha" ref="1e15a9f2c0dc1cba158755633574fbc7" args="(PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool Ogre::PixelUtil::hasAlpha           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Shortcut method to determine if the format has an alpha component. 
<p>

</div>
</div><p>
<a class="anchor" name="478b8c3bbb3bc516f3a06524fc1d9f4b"></a><!-- doxytag: member="Ogre::PixelUtil::isFloatingPoint" ref="478b8c3bbb3bc516f3a06524fc1d9f4b" args="(PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool Ogre::PixelUtil::isFloatingPoint           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Shortcut method to determine if the format is floating point. 
<p>

</div>
</div><p>
<a class="anchor" name="c4fcce8523b25011939624bfe2572314"></a><!-- doxytag: member="Ogre::PixelUtil::isCompressed" ref="c4fcce8523b25011939624bfe2572314" args="(PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool Ogre::PixelUtil::isCompressed           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Shortcut method to determine if the format is compressed. 
<p>

</div>
</div><p>
<a class="anchor" name="51407cd07e47f24263942453ee4f93af"></a><!-- doxytag: member="Ogre::PixelUtil::isDepth" ref="51407cd07e47f24263942453ee4f93af" args="(PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool Ogre::PixelUtil::isDepth           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Shortcut method to determine if the format is a depth format. 
<p>

</div>
</div><p>
<a class="anchor" name="a6a3f3c1e6b98b537ce6dfed949afa3c"></a><!-- doxytag: member="Ogre::PixelUtil::isNativeEndian" ref="a6a3f3c1e6b98b537ce6dfed949afa3c" args="(PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool Ogre::PixelUtil::isNativeEndian           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Shortcut method to determine if the format is in native endian format. 
<p>

</div>
</div><p>
<a class="anchor" name="7e2ff8ebe2e05d6c0dc5ab725b294cf8"></a><!-- doxytag: member="Ogre::PixelUtil::isLuminance" ref="7e2ff8ebe2e05d6c0dc5ab725b294cf8" args="(PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool Ogre::PixelUtil::isLuminance           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Shortcut method to determine if the format is a luminance format. 
<p>

</div>
</div><p>
<a class="anchor" name="cb83c9058ba34602be4e07e4d7ce1d2d"></a><!-- doxytag: member="Ogre::PixelUtil::isValidExtent" ref="cb83c9058ba34602be4e07e4d7ce1d2d" args="(size_t width, size_t height, size_t depth, PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool Ogre::PixelUtil::isValidExtent           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>height</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>depth</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Return wether a certain image extent is valid for this image format. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>width</em>&nbsp;</td><td>The width of the area </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>height</em>&nbsp;</td><td>The height of the area </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>depth</em>&nbsp;</td><td>The depth of the area </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>format</em>&nbsp;</td><td>The format of the area </td></tr>
  </table>
</dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>For non-compressed formats, this is always true. For DXT formats, only sizes with a width and height multiple of 4 and depth 1 are allowed. </dd></dl>

</div>
</div><p>
<a class="anchor" name="91159ec54a34fca27ccc7621c9b6d957"></a><!-- doxytag: member="Ogre::PixelUtil::getBitDepths" ref="91159ec54a34fca27ccc7621c9b6d957" args="(PixelFormat format, int rgba[4])" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::PixelUtil::getBitDepths           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>rgba</em>[4]</td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gives the number of bits (RGBA) for a format. 
<p>
See remarks. <dl class="remark" compact><dt><b>Remarks:</b></dt><dd>For non-colour formats (dxt, depth) this returns [0,0,0,0]. </dd></dl>

</div>
</div><p>
<a class="anchor" name="0ede5a1484d8c57a2cdc87eb4f6d7676"></a><!-- doxytag: member="Ogre::PixelUtil::getBitMasks" ref="0ede5a1484d8c57a2cdc87eb4f6d7676" args="(PixelFormat format, uint32 rgba[4])" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::PixelUtil::getBitMasks           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>format</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a>&nbsp;</td>
          <td class="paramname"> <em>rgba</em>[4]</td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gives the masks for the R, G, B and A component. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Only valid for native endian formats </dd></dl>

</div>
</div><p>
<a class="anchor" name="ec27f7358f77fabc0c9e68ce35b5af69"></a><!-- doxytag: member="Ogre::PixelUtil::getFormatName" ref="ec27f7358f77fabc0c9e68ce35b5af69" args="(PixelFormat srcformat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> Ogre::PixelUtil::getFormatName           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>srcformat</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the name of an image format. 
<p>

</div>
</div><p>
<a class="anchor" name="2a9e6ac27e4a4cb2d890d322b3f12c8e"></a><!-- doxytag: member="Ogre::PixelUtil::isAccessible" ref="2a9e6ac27e4a4cb2d890d322b3f12c8e" args="(PixelFormat srcformat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool Ogre::PixelUtil::isAccessible           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>srcformat</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns wether the format can be packed or unpacked with the <a class="el" href="classOgre_1_1PixelUtil.html#793a7ae2bb8edec89ab520958ac33f40" title="Pack a colour value to memory.">packColour()</a> and <a class="el" href="classOgre_1_1PixelUtil.html#9b90b16c6c5c8a9fefd42e06a1bd99dc" title="Unpack a colour value from memory.">unpackColour()</a> functions. 
<p>
This is generally not true for compressed and depth formats as they are special. It can only be true for formats with a fixed element size. <dl class="return" compact><dt><b>Returns:</b></dt><dd>true if yes, otherwise false </dd></dl>

</div>
</div><p>
<a class="anchor" name="90ebf73b3830df2e83d529e60fd8c385"></a><!-- doxytag: member="Ogre::PixelUtil::getComponentType" ref="90ebf73b3830df2e83d529e60fd8c385" args="(PixelFormat fmt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#c8f59c884998d9f84d9ea4c66e4c29fe">PixelComponentType</a> Ogre::PixelUtil::getComponentType           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>fmt</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the component type for a certain pixel format. 
<p>
Returns PCT_BYTE in case there is no clear component type like with compressed formats. This is one of PCT_BYTE, PCT_SHORT, PCT_FLOAT16, PCT_FLOAT32. 
</div>
</div><p>
<a class="anchor" name="e81ba2514ca7f5a53c84bb515de2ade0"></a><!-- doxytag: member="Ogre::PixelUtil::getComponentCount" ref="e81ba2514ca7f5a53c84bb515de2ade0" args="(PixelFormat fmt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static size_t Ogre::PixelUtil::getComponentCount           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>fmt</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the component count for a certain pixel format. 
<p>
Returns 3(no alpha) or 4 (has alpha) in case there is no clear component type like with compressed formats. 
</div>
</div><p>
<a class="anchor" name="601fd16392331e7ddce6bcc455b5729d"></a><!-- doxytag: member="Ogre::PixelUtil::getFormatFromName" ref="601fd16392331e7ddce6bcc455b5729d" args="(const String &amp;name, bool accessibleOnly=false, bool caseSensitive=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> Ogre::PixelUtil::getFormatFromName           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>accessibleOnly</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>caseSensitive</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the format from given name. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The string of format name </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>accessibleOnly</em>&nbsp;</td><td>If true, non-accessible format will treat as invalid format, otherwise, all supported format are valid. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>caseSensitive</em>&nbsp;</td><td>Should be set true if string match should use case sensitivity. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The format match the format name, or PF_UNKNOWN if is invalid name. </dd></dl>

</div>
</div><p>
<a class="anchor" name="32443d01d6399f778fce913ca80b0eee"></a><!-- doxytag: member="Ogre::PixelUtil::getBNFExpressionOfPixelFormats" ref="32443d01d6399f778fce913ca80b0eee" args="(bool accessibleOnly=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> Ogre::PixelUtil::getBNFExpressionOfPixelFormats           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>accessibleOnly</em> = <code>false</code>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the BNF expression of the pixel-formats. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>The string returned by this function is intented to use as a BNF expression to work with <a class="el" href="classOgre_1_1Compiler2Pass.html" title="Compiler2Pass is a generic 2 pass compiler/assembler.">Compiler2Pass</a>. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>accessibleOnly</em>&nbsp;</td><td>If true, only accessible pixel format will take into account, otherwise all pixel formats list in PixelFormat enumeration will being returned. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>A string contains the BNF expression. </dd></dl>

</div>
</div><p>
<a class="anchor" name="e127c3e6145af784e7d2d3734681a75a"></a><!-- doxytag: member="Ogre::PixelUtil::getFormatForBitDepths" ref="e127c3e6145af784e7d2d3734681a75a" args="(PixelFormat fmt, ushort integerBits, ushort floatBits)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> Ogre::PixelUtil::getFormatForBitDepths           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>&nbsp;</td>
          <td class="paramname"> <em>integerBits</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>&nbsp;</td>
          <td class="paramname"> <em>floatBits</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the similar format but acoording with given bit depths. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>fmt</em>&nbsp;</td><td>The original foamt. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>integerBits</em>&nbsp;</td><td>Preferred bit depth (pixel bits) for integer pixel format. Available values: 0, 16 and 32, where 0 (the default) means as it is. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>floatBits</em>&nbsp;</td><td>Preferred bit depth (channel bits) for float pixel format. Available values: 0, 16 and 32, where 0 (the default) means as it is. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The format that similar original format with bit depth according with preferred bit depth, or original format if no convertion occuring. </dd></dl>

</div>
</div><p>
<a class="anchor" name="793a7ae2bb8edec89ab520958ac33f40"></a><!-- doxytag: member="Ogre::PixelUtil::packColour" ref="793a7ae2bb8edec89ab520958ac33f40" args="(const ColourValue &amp;colour, const PixelFormat pf, void *dest)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::PixelUtil::packColour           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1ColourValue.html">ColourValue</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>colour</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>pf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>dest</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Pack a colour value to memory. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>colour</em>&nbsp;</td><td>The colour </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pf</em>&nbsp;</td><td>Pixelformat in which to write the colour </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dest</em>&nbsp;</td><td>Destination memory location </td></tr>
  </table>
</dl>

<p>Referenced by <a class="el" href="OgreImageResampler_8h-source.html#l00097">Ogre::LinearResampler::scale()</a>.</p>

</div>
</div><p>
<a class="anchor" name="f0658994fbf0337d455ac9aa74ee8084"></a><!-- doxytag: member="Ogre::PixelUtil::packColour" ref="f0658994fbf0337d455ac9aa74ee8084" args="(const uint8 r, const uint8 g, const uint8 b, const uint8 a, const PixelFormat pf, void *dest)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::PixelUtil::packColour           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>&nbsp;</td>
          <td class="paramname"> <em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>&nbsp;</td>
          <td class="paramname"> <em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>&nbsp;</td>
          <td class="paramname"> <em>b</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>pf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>dest</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Pack a colour value to memory. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>r,g,b,a</em>&nbsp;</td><td>The four colour components, range 0x00 to 0xFF </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pf</em>&nbsp;</td><td>Pixelformat in which to write the colour </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dest</em>&nbsp;</td><td>Destination memory location </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="29490454e6327a0429d19533880f6e2c"></a><!-- doxytag: member="Ogre::PixelUtil::packColour" ref="29490454e6327a0429d19533880f6e2c" args="(const float r, const float g, const float b, const float a, const PixelFormat pf, void *dest)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::PixelUtil::packColour           </td>
          <td>(</td>
          <td class="paramtype">const float&nbsp;</td>
          <td class="paramname"> <em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float&nbsp;</td>
          <td class="paramname"> <em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float&nbsp;</td>
          <td class="paramname"> <em>b</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const float&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>pf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>dest</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Pack a colour value to memory. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>r,g,b,a</em>&nbsp;</td><td>The four colour components, range 0.0f to 1.0f (an exception to this case exists for floating point pixel formats, which don't clamp to 0.0f..1.0f) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pf</em>&nbsp;</td><td>Pixelformat in which to write the colour </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dest</em>&nbsp;</td><td>Destination memory location </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="9b90b16c6c5c8a9fefd42e06a1bd99dc"></a><!-- doxytag: member="Ogre::PixelUtil::unpackColour" ref="9b90b16c6c5c8a9fefd42e06a1bd99dc" args="(ColourValue *colour, PixelFormat pf, const void *src)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::PixelUtil::unpackColour           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ColourValue.html">ColourValue</a> *&nbsp;</td>
          <td class="paramname"> <em>colour</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>pf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const void *&nbsp;</td>
          <td class="paramname"> <em>src</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Unpack a colour value from memory. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>colour</em>&nbsp;</td><td>The colour is returned here </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pf</em>&nbsp;</td><td>Pixelformat in which to read the colour </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>src</em>&nbsp;</td><td>Source memory location </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="6599a03e4d51ef96f373f47253e2b9e3"></a><!-- doxytag: member="Ogre::PixelUtil::unpackColour" ref="6599a03e4d51ef96f373f47253e2b9e3" args="(uint8 *r, uint8 *g, uint8 *b, uint8 *a, PixelFormat pf, const void *src)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::PixelUtil::unpackColour           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> *&nbsp;</td>
          <td class="paramname"> <em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> *&nbsp;</td>
          <td class="paramname"> <em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> *&nbsp;</td>
          <td class="paramname"> <em>b</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>pf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const void *&nbsp;</td>
          <td class="paramname"> <em>src</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Unpack a colour value from memory. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>r,g,b,a</em>&nbsp;</td><td>The colour is returned here (as byte) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pf</em>&nbsp;</td><td>Pixelformat in which to read the colour </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>src</em>&nbsp;</td><td>Source memory location </td></tr>
  </table>
</dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This function returns the colour components in 8 bit precision, this will lose precision when coming from PF_A2R10G10B10 or floating point formats. </dd></dl>

</div>
</div><p>
<a class="anchor" name="e1448ad9a222ed03918f2e94a057612c"></a><!-- doxytag: member="Ogre::PixelUtil::unpackColour" ref="e1448ad9a222ed03918f2e94a057612c" args="(float *r, float *g, float *b, float *a, PixelFormat pf, const void *src)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::PixelUtil::unpackColour           </td>
          <td>(</td>
          <td class="paramtype">float *&nbsp;</td>
          <td class="paramname"> <em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&nbsp;</td>
          <td class="paramname"> <em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&nbsp;</td>
          <td class="paramname"> <em>b</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>pf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const void *&nbsp;</td>
          <td class="paramname"> <em>src</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Unpack a colour value from memory. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>r,g,b,a</em>&nbsp;</td><td>The colour is returned here (as float) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pf</em>&nbsp;</td><td>Pixelformat in which to read the colour </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>src</em>&nbsp;</td><td>Source memory location </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="8d05d1cc543c2618b7ec790648d0ccce"></a><!-- doxytag: member="Ogre::PixelUtil::bulkPixelConversion" ref="8d05d1cc543c2618b7ec790648d0ccce" args="(void *src, PixelFormat srcFormat, void *dest, PixelFormat dstFormat, unsigned int count)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::PixelUtil::bulkPixelConversion           </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>srcFormat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>dest</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>dstFormat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>count</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Convert consecutive pixels from one format to another. 
<p>
No dithering or filtering is being done. Converting from RGB to luminance takes the R channel. In case the source and destination format match, just a copy is done. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>src</em>&nbsp;</td><td>Pointer to source region </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>srcFormat</em>&nbsp;</td><td>Pixel format of source region </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dst</em>&nbsp;</td><td>Pointer to destination region </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dstFormat</em>&nbsp;</td><td>Pixel format of destination region </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="9f6e459a0f92c0c8e6bf4f20ee3a771a"></a><!-- doxytag: member="Ogre::PixelUtil::bulkPixelConversion" ref="9f6e459a0f92c0c8e6bf4f20ee3a771a" args="(const PixelBox &amp;src, const PixelBox &amp;dst)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void Ogre::PixelUtil::bulkPixelConversion           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>dst</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Convert pixels from one format to another. 
<p>
No dithering or filtering is being done. Converting from RGB to luminance takes the R channel. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>src</em>&nbsp;</td><td><a class="el" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory...">PixelBox</a> containing the source pixels, pitches and format </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dst</em>&nbsp;</td><td><a class="el" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory...">PixelBox</a> containing the destination pixels, pitches and format </td></tr>
  </table>
</dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The source and destination boxes must have the same dimensions. In case the source and destination format match, a plain copy is done. </dd></dl>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgrePixelFormat_8h-source.html">OgrePixelFormat.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:51:47 2008
</p>
</body>
</html>
